#!/usr/bin/python
##### Amplituda prilagoditve in prevajalne funkcije - S53MV 09.12.2018 #####

import math	#uporabljene funkcije

amin=-50	#minimalna amplituda [dB]
amax=0		#maksimalna amplituda [dB]
fmin=1		#zacetna frekvenca [Hz]
fmax=5e+7	#koncna frekvenca [Hz]
q=50		#kvaliteta tuljav
zk=complex(120,0)	#karakteristicna impedanca [Ohm]

def sito(u,z,w,q):	#izracun prevajalne funkcije LCC-BPF (120ohm)
	c=100e-12	#zaporedni kondenzator 100pF
	z=z+1/complex(0,w*c)
	y=1/z		#Norton
	i=u/z
	j=1
	while j<=8:
		c=100e-12	#vzporedni kondenzator 100pF in tuljava 270nH
		l=270e-9
		y=y+complex(0,w*c)+1/complex(w*l/q,w*l)
		z=1/y		#Thevenin
		u=i/y
		c=47e-12	#zaporedni kondenzator 47pF
		z=z+1/complex(0,w*c)
		y=1/z		#Norton
		i=u/z
		j=j+1
	c=100e-12	#vzporedni kondenzator 100pF in tuljava 270nH
	l=270e-9
	y=y+complex(0,w*c)+1/complex(w*l/q,w*l)
	z=1/y		#Thevenin
	u=i/y
	c=100e-12	#zaporedni kondenzator 100pF
	z=z+1/complex(0,w*c)
	return [u,z]

print 'Racunanje odziva sita...'
xx=[]		#polja za risanje grafa
yy=[]
zz=[]
f=fmin		#zacetna frekvenca
k=(fmax-fmin)/800	#800 frekvencnih korakov
while f<=fmax:
	xx=xx+[f]	#polje frekvenc
	w=2*math.pi*f
	u=complex(2,0)	#vir (2V,zk)
	z=zk
	[u,z]=sito(u,z,w,q)
#	[u,z]=sito(u,z,w,q)
#	[u,z]=sito(u,z,w,q)
	g=20*math.log10(abs((z-zk)/(z+zk)))	#prilagoditev [dB]
	zz=zz+[g]	#polje prilagoditve
	a=20*math.log10(abs(u*zk/(z+zk)))	#prevajalna funkcija [dB]
	yy=yy+[a]	#polje prevajalne funkcije
	f=f+k

print 'Risanje matplotlib...'
import matplotlib.pyplot as plt		#risanje grafov funkcij
plt.plot(xx,zz,'c-')	#prilagoditev
plt.plot(xx,yy,'r-')	#prevajalna funkcija
plt.axis([fmin,fmax,amin,amax])
plt.title('Prevajalna funkcija in prilagoditev sita LCC-BPF @ '+str(zk))
plt.xlabel('Frekvenca [Hz]')
plt.ylabel('Amplituda [dB]')
plt.grid(True)
plt.show()

#konec programa

